#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum RetentionPolicyType {
    #[serde(rename = "KEEP_UNTIL_EXPIRY")]
    KeepUntilExpiry,
    #[serde(rename = "KEEP_FOREVER")]
    KeepForever,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl RetentionPolicyType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            RetentionPolicyType::KeepUntilExpiry => "KEEP_UNTIL_EXPIRY",
            RetentionPolicyType::KeepForever => "KEEP_FOREVER",
            RetentionPolicyType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for RetentionPolicyType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for RetentionPolicyType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for RetentionPolicyType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<RetentionPolicyType, conjure_object::plain::ParseEnumError> {
        match v {
            "KEEP_UNTIL_EXPIRY" => Ok(RetentionPolicyType::KeepUntilExpiry),
            "KEEP_FOREVER" => Ok(RetentionPolicyType::KeepForever),
            v => v.parse().map(|v| RetentionPolicyType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for RetentionPolicyType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<RetentionPolicyType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the RetentionPolicyType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
